#!/usr/bin/env node
import u from "node:path";
import t from "node:fs";
import S from "lodash.get";
import v from "lodash.set";
import e from "chalk";
import { getKey as J, paramsResolve as P } from "./utils/resolve.mjs";
const O = async (a) => {
  const { sourceJsonFilePath: c, injectKeyPath: f, injectInfoFilePath: l } = a, i = process.cwd();
  if (!c.endsWith(".json"))
    return console.log(e.red("源文件必须是json")), process.exit(1);
  if (!l.endsWith(".json"))
    return console.log(e.red("注入文件必须是json")), process.exit(1);
  const m = u.resolve(i, c), p = t.readFileSync(m, "utf-8"), g = JSON.parse(p), s = f.reduce(
    (n, h) => {
      const { key: y, targetKey: d, paramsList: j } = J(h), F = S(g, y), I = P({
        valueInit: F,
        paramsList: j
      });
      return v(n, d, I), n;
    },
    {}
  ), o = u.resolve(i, l), r = JSON.stringify(s, null, 2);
  if (t.existsSync(o)) {
    const n = t.readFileSync(o, "utf-8");
    if (r === n)
      return console.log(e.gray("注入文件已存在且内容相同，无需重复注入")), s;
    console.log(e.blue("文件内容变化,开始覆盖注入文件"));
  } else
    console.log(e.green("开始注入文件"));
  return t.writeFileSync(o, r), console.log(
    e.green(`文件注入成功: ${o}`),
    e.blue(r)
  ), s;
};
export {
  O as handler
};
